#include <cstdio>
#include <cstdlib>
#include <cstdarg>
#include <cmath>

#define YL "jalu"
#define IN (argc > 1 ? argv[1] : YL "sis.txt")
#define OUT (argc > 3 ? argv[3] : YL "val.txt")
#define HINT (argc > 2 ? argv[2] : YL "xxx.txt")
#define MAXLINE 100
#define EPSILON 0.001001

void ERR(const char *s, ...) {
	fprintf(stderr, "Error: ");
	va_list ap;
	va_start(ap, s);
	vfprintf(stderr, s, ap);
	va_end(ap);
	fprintf(stderr, "\n");
	exit(1);
}

void OK(int n, const char *s, ...) {
	printf("%d\n", n);
	va_list ap;
	va_start(ap, s);
	vfprintf(stderr, s, ap);
	va_end(ap);
	fprintf(stderr, "\n");
	exit(0);
}

char s[MAXLINE], ss[10];
int n;

int lh, lo;
double vh, vo;

int main(int argc, const char *argv[]) {
	FILE *hint = fopen(HINT, "rt");
	if (!hint) {
		ERR("Viga vihjefaili avamisel");
	}
	FILE *out = fopen(OUT, "rt");
	if (!out) {
		OK(0, "Viga väljundfaili avamisel");
	}
	// teepikkus
	if (fscanf(hint, "%dm", &lh) != 1) {
		ERR("Viga vihjefaili lugemisel");
	}
	if (fgets(s, sizeof(s), out) == NULL) {
		OK(0, "Enneaegne väljundfaili lõpp");
	}
	if (sscanf(s, "%dm%n", &lo, &n) != 1) {
		OK(0, "Viga väljundfaili real 1");
	}
	if (lo != lh) {
		OK(0, "Vale vastus real 1: on %d, peaks olema %d", lo, lh);
	}
	if (sscanf(s + n, "%3s", ss) > 0) {
		OK(0, "Viga väljundfaili real 1");
	}
	// keskmine kiirus
	if (fscanf(hint, "%lfkm/h", &vh) != 1) {
		ERR("Viga vihjefaili lugemisel");
	}
	if (fgets(s, sizeof(s), out) == NULL) {
		OK(0, "Enneaegne väljundfaili lõpp");
	}
	if (sscanf(s, "%lfkm/h%n", &vo, &n) != 1) {
		OK(0, "Viga väljundfaili real 2");
	}
	if (fabs(vo - vh) > EPSILON) {
		OK(0, "Vale vastus real 2: on %0.6lf, peaks olema %0.6lf", vo, vh);
	}
	if (sscanf(s + n, "%3s", ss) > 0) {
		OK(0, "Viga väljundfaili real 2");
	}
	// muud läbu?
	if (fscanf(out, "%3s", ss) > 0) {
		OK(0, "Liigsed andmed väljundfaili lõpus");
	}
	OK(1, "OK");
}
