#include <iostream>
#include <fstream>
#include <cstdlib>
#include <ctime>
#include <algorithm>
using namespace std;

const char* actions = "KPR";
int get_random() {
    ifstream in("/dev/urandom", ios::binary);
    int num;
    in.read((char*)&num, sizeof(num));
    return num;
}
void init_randomness() { srand(get_random()); }
char random_action() { return actions[rand() % 3]; }
char my_turn, their_turn;

int utility[3]; // For each of my turns count its potential score.

inline int action_to_int(char action) {
    switch(action) {
            case 'K':
                    return 0;
            case 'P':
                    return 1;
            default:
                    return 2;
    }
}

int score(int my_v, int their_v) {
    int diff = my_v - their_v;
    diff = diff % 3;
    if (diff < 0) diff += 3;
    return (diff == 2) ? -1 : diff;
}

int main() {
    init_randomness();
    utility[0] = utility[1] = utility[2] = 0;

    do {
        // With a small probability do a random move
        if (rand() % 5 == 0) {
           my_turn = random_action();
        }
        else {
           // Find the turn with the best utility so far
           int u = max_element(&utility[0], &utility[0] + 3) - &utility[0];
           my_turn = actions[u];
        }
        //for (int i = 0; i < 3; i++) cout << utility[i] << " ";
        //cout << endl;
        cout << my_turn << endl;
        cin >> their_turn;
        // Update the utility of <my_turn>
        int my_v = action_to_int(my_turn);
        int their_v = action_to_int(their_turn);
        utility[my_v] += score(my_v, their_v);
    }
    while (their_turn != 'L');

    return 0;
}


