//Autor: Oliver-Matis Lill
//20p grupid 3, 4
//O(2^(n + m) * (n + m) ^ 2)
//Tyyp: DP, variantide labivaatlus
//
//Travelling salesman DP stiilis parem variantide labivaatlus
//Kasutab ara asjaolu, et kui meil on mingi hulk poisse ja tydrukuid juba
//Paarides, siis edasiste valikute tegemises ei ole vahet, kuidas need paarides
//Olevad peolised on paaridesse pandud, loeb ainult, kes on paarides.

#include<iostream>
#include<fstream>
using namespace std;

int n, m, k, p1, p2, optn = 1000000000, optcomb;
bool conn[19][19], valid[16777216];


int main() {
	ifstream in("pidusis.txt");
	in >> n >> m >> k;
	
	for(int i=0;i<k;i++) {
		in >> p1 >> p2;
		
		conn[p1-1][p2-1] = true;
	}
	
	valid[0] = true;
	
	for(int comb = 0; comb < (1 << (n+m)); comb++) {
		if(!valid[comb])
			continue;
			
		bool sated = true;
		int ninp = 0;
		
		for(int i=0;i<m;i++)
			if((comb & (1 << i ) ) != 0)
				ninp++;
		
		for(int i=0;i<n;i++)
			for(int j=0;j<m;j++)
				if(conn[i][j] && (comb & (1 << (m + i) ) ) == 0 && (comb & (1 << j) ) == 0 ) {
					sated = false;
					
					valid[comb + (1 << (m+i) ) + (1 << j)] = true;
				}
		
		if(sated && ninp < optn) {
			optn = ninp;
			optcomb = comb;
		}
	}
	
	ofstream out("piduval.txt");
	
	out << optn << '\n';
	
	while(optcomb > 0) {
		for(int i=0;i<n;i++)
			for(int j=0;j<m;j++)
				if(conn[i][j] && (optcomb & (1 << (m + i) ) ) != 0 && (optcomb & (1 << j) ) != 0 ) {
				
					int prev = optcomb - (1 << (m+i) ) - (1 << j);
					
					if(valid[prev]) {
						out << i+1 << ' ' << j+1 << '\n';
						optcomb = prev;
					}
				}
	}
	
	return 0;
}


















