//Autor: Oliver-Matis Lill
//50p grupid 1, 2, 3, 4, 5
//O(2^n * (n + m) ^ 3) lahendus heade (< 1) konstantidega
//Tyyp: variantide labivaatlus, maksimaalne voog
//
//Lahendus kombineerib variantide labivaatlust ja maksimaalse voo leidmist
//Lahenduses valitakse mingi hulk tydrukuid ja "lukustatakse need paaridesse"
//Nendele tydrukutele seatakse vastavusse poisid, nii et ulejaanuid tudrukuid
//ei saaks paaridesse panna. Iga tydrukute hulga jaoks vaadatakse, kas seda
//voimalik teha ja nende hulkade seast millel on voimalik seda teha valitakse
//minimaalne.
//
//Natukese kombinatoorika ja arvutamisega on voimalik moistlikult keerukalt
//leida, miks see lahendus peaks antud piirangute juures aja sisse mahtuma

#include<iostream>
#include<fstream>
#include<vector>
#define f first
#define s second
#define mp make_pair
using namespace std;

int n, m, k, p1, p2, optnummatch = 1000000000, fordconn[40][40];
bool conn[19][19], boychoice[19], explr[40];

vector<pair<int, int> > optmatch;
vector<int> forde[40], girl, boy;


//------------------------------------------------------------------------
//Augmenting function

bool dfs(int pos, int dest) {
	if(pos == dest)
		return true;
	
	if(explr[pos])
		return false;
	explr[pos] = true;
		
	for(int i=0;i<forde[pos].size();i++)
		if(fordconn[pos][forde[pos][i]] > 0)
			if(dfs(forde[pos][i], dest) ) {
			
				fordconn[pos][forde[pos][i]] --;
				fordconn[forde[pos][i]][pos] ++;
				return true;
			}
	
	return false;
}

//------------------------------------------------------------------------
//Main function here

int main() {
	ifstream in("pidusis.txt");
	in >> n >> m >> k;
	
	for(int i=0;i<k;i++) {
		in >> p1 >> p2;
		
		conn[p1-1][p2-1] = true;
	}
	
	
	//Here we process all the possible girl combinations
	
	for(int comb = 0; comb < (1 << n); comb++) {
		for(int i=0;i<m;i++)
			boychoice[i] = false;
			
		int nboys = 0, ngirls = 0;
		girl.clear();
		boy.clear();
		
		for(int i=0;i<n;i++) {
			if( (comb & (1 << i) ) == 0) {
				for(int j=0;j<m;j++)
					if(conn[i][j])
						nboys += !boychoice[j], boychoice[j] = true;
			}
			else {
				ngirls++;
				girl.push_back(i);
			}
		}
		
		if(nboys > ngirls)
			continue;
		
		for(int i=0;i<m;i++)
			if(boychoice[i])
				boy.push_back(i);
			
		
		//Here we initialize the flow graph
		
		for(int i=0;i<ngirls;i++) {
			for(int j=0;j<nboys;j++) {
			
				if(conn[girl[i]][boy[j]]) {
					forde[i+1].push_back(ngirls + j + 1);
					forde[ngirls + j + 1].push_back(i+1);
				}
			
				fordconn[i+1][ngirls + j + 1] = conn[girl[i]][boy[j]];
			}
			
			fordconn[0][i+1] = 1;
			forde[0].push_back(i+1);
			forde[i+1].push_back(0);
		}
		
		
		for(int i=0;i<nboys;i++) {
			fordconn[ngirls + i + 1] [ngirls + nboys + 1] = 1;
			forde[ngirls + i + 1].push_back(ngirls + nboys + 1);
			forde[ngirls + nboys + 1].push_back(ngirls + i + 1);
		}
				
		
		int flow = -1;
		
		do {
			for(int i=0;i<ngirls + nboys + 2;i++)
				explr[i] = false;
			
			flow++;
		}while(dfs(0, ngirls + nboys + 1) );
		
		
		//Next we update the result
		
		if(flow == nboys && ngirls < optnummatch) {
			optnummatch = ngirls;
			optmatch.clear();
			
			for(int i=0;i<ngirls;i++) {
				if(fordconn[0][i+1] == 0) {
					for(int j=0;j<nboys;j++)
						if(fordconn[ngirls + j + 1][i+1] == 1)
							optmatch.push_back(mp(girl[i] + 1, boy[j] + 1) );
				}
				
				else {
					for(int j=0;j<m;j++)
						if(!boychoice[j] && conn[girl[i]][j] == true) {
							optmatch.push_back(mp(girl[i] + 1, j + 1) );
							boychoice[j] = true;
							break;
						}
				}
			}
		}
		
		//Finally we clean up the ford matrix
		
		for(int i=0;i<ngirls + nboys + 2; i++ ) {
			for(int j=0;j<forde[i].size();j++)
				fordconn[i][forde[i][j]] = 0;
			
			forde[i].clear();
		}
	}
	
	
	//Now we print out the result
	
	ofstream out("piduval.txt");
	out << optnummatch << '\n';
	
	for(int i=0;i<optmatch.size();i++)
		out << optmatch[i].f << ' ' << optmatch[i].s << '\n';
	
	return 0;
}



























