// 2014-11-10 programmeerimisvõistlus
// Ülesanne: PUU PÖÖRAMINE
// Autor: Ahto Truu
// Testitud: GCC 4.6.1 / MinGW32

#include <fstream>
using namespace std;

ifstream sisf("puusis.txt");
ofstream valf("puuval.txt");

struct tipp { // ühe tipu andmed
	int m; // alluvate arv;
	int *a; // alluvate numbrid
	int y; // ülemuse number; -1, kui ei ole
	int k; // lehte K sisaldav alluv; -1, kui ei ole
};

int n; // tippude arv
tipp *t; // tipud
int k; // uus juur

int main() {
	// loeme sisendi
	sisf >> n >> k;
	t = new tipp[1 + n]; // t[0] jääb kasutamata
	for (int i = 1; i <= n; ++i) {
		sisf >> t[i].m;
		t[i].a = new int[t[i].m];
		for (int j = 0; j < t[i].m; ++j) {
			sisf >> t[i].a[j];
		}
		t[i].y = t[i].k = -1; // algväärtustame
	}

	// märgime iga tipu ülemuse
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j < t[i].m; ++j) {
			int a = t[i].a[j]; // alluva number
			t[a].y = i; // märgime ülemuse numbri
		}
	}

	// märgime tee lehest K algse juureni 1
	for (int i = k; i != 1; ) {
		int y = t[i].y; // ülemuse number
		for (int j = 0; j < t[y].m; ++j) {
			if (t[y].a[j] == i) {
				t[y].k = j; // märgime, millise alluva all on K
			}
		}
		i = y; // jätkame tee märkimist ülemuse juurest
	}

	// väljastame uue puu struktuuri
	for (int i = 1; i <= n; ++i) {
		if (i != k && t[i].k == -1) {
			// see tipp pole teel lehest K algses puu juureni
			// selle tipu alluvate nimekiri pööramisel ei muutu
			valf << t[i].m;
			for (int j = 0; j < t[i].m; ++j) {
				valf << " " << t[i].a[j];
			}
			valf << "\n";
		} else {
			// see tipp on teel lehest K algse puu juureni
			// siis saab samal teel olev alluv tipu uueks ülemuseks
			// ja selle tipu uued alluvad on:
			// 1. need alluvad, mis enne olid K teest paremal
			// 2. endine ülemus (kui tipp pole juur)
			// 3. need alluvad, mis enne olid K teest vasakul
			int m = t[i].m; // alluvate arv pärast pööramist
			if (t[i].k != -1) { // kui K oli selle tipu all
				--m; // siis see tipp kaotab ühe alluva
			}
			if (t[i].y != -1) { // kui sellel tipul oli ülemus
				++m; // siis see tipp saab uue alluva
			}
			valf << m;
			// lehe K teest paremal olevad alluvad
			for (int j = t[i].k + 1; j < t[i].m; ++j) {
				valf << " " << t[i].a[j];
			}
			// ülemus, kui on
			if (t[i].y != -1) {
				valf << " " << t[i].y;
			}
			// lehe K teest vasakul olevad alluvad
			for (int j = 0; j < t[i].k; ++j) {
				valf << " " << t[i].a[j];
			}
			valf << "\n";
		}
	}

	// mälu vabastamisega ei hakka vaeva nägema
	// opsüsteem teeb seda programmi lõppedes niigi

	return 0;
}
