﻿// Ribade ülesanne, N^2 keerukusega alt üles lahendus

using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;

namespace Ribad1
{
    public class Ribad1
    {
        private class Ribbon
        {
            public Ribbon(int start, int end, int color)
            {
                Start = start;
                End = end;
                Color = color;
            }

            public int Start;
            public int End;
            public readonly int Color;
        }

        private static void Main()
        {
            LinkedList<Ribbon> result = new LinkedList<Ribbon>();
            using (StreamReader reader = new StreamReader("ribasis.txt"))
            {
                int[] parts = reader.ReadLine().Split().Select(int.Parse).ToArray();
                int l = parts[0];
                int n = parts[1];
                result.AddFirst(new Ribbon(0, l, 0));

                for (int i = 0; i < n; i++)
                {
                    if ((i - 1) % 10000 == 0)
                    {
                        Console.Write(".");
                    }

                    parts = reader.ReadLine().Split().Select(int.Parse).ToArray();
                    Ribbon newRibbon = new Ribbon(parts[1], parts[2], parts[0]);

                    LinkedListNode<Ribbon> nextNode = result.First;
                    bool added = false;

                    do
                    {
                        LinkedListNode<Ribbon> currentNode = nextNode;
                        nextNode = currentNode.Next;
                        Ribbon oldRibbon = currentNode.Value;

                        if (newRibbon.Start >= oldRibbon.End)
                        {
                            continue;
                        }

                        // võimalused:
                        if (newRibbon.Start <= oldRibbon.Start)
                        {
                            if (!added)
                            {
                                result.AddBefore(currentNode, newRibbon);
                                added = true;
                            }

                            // 1. uus riba katab vana täielikult, eemaldame vana
                            if (newRibbon.End >= oldRibbon.End)
                            {
                                result.Remove(currentNode);
                            }
                            else // 2. uus riba lõikab vana eestpoolt
                            {
                                oldRibbon.Start = newRibbon.End;
                            }
                        }
                        else
                        {
                            // 3. uus on vana sees, lisame 2 riba
                            if (newRibbon.End < oldRibbon.End)
                            {
                                Ribbon secondPart = new Ribbon(newRibbon.End, oldRibbon.End, oldRibbon.Color);
                                oldRibbon.End = newRibbon.Start;
                                LinkedListNode<Ribbon> newNode = result.AddAfter(currentNode, newRibbon);
                                result.AddAfter(newNode, secondPart);
                                added = true;
                            }
                            else // 4. uus riba lõikab vana tagantpoolt
                            {
                                oldRibbon.End = newRibbon.Start;
                                result.AddAfter(currentNode, newRibbon);
                                added = true;
                            }
                        }
                    } while (nextNode != null && nextNode.Value.Start <= newRibbon.End);
                }
            }

            // eemaldame mitmekordsed ribad
            for (var currentNode = result.First; currentNode != null; currentNode = currentNode.Next)
            {
                while (currentNode.Next != null && currentNode.Value.Color == currentNode.Next.Value.Color)
                {
                    currentNode.Value.End = currentNode.Next.Value.End;
                    result.Remove(currentNode.Next);
                }
            }

            using (StreamWriter writer = new StreamWriter("ribaval.txt"))
            {
                foreach (Ribbon ribbon in result)
                {
                    writer.WriteLine("{0} {1}", ribbon.Color, ribbon.End - ribbon.Start);
                }
            }
        }
    }
}
