#include <iostream>
#include <fstream>
#define MAX(a, b) ((a) > (b) ? (a) : (b))
#define MIN(a, b) ((a) < (b) ? (a) : (b))
using namespace std;

struct Carpet {
    long long int n;
    long long int s;
    long long int e;
    long long int w;
};

long long int N; // toa laius
long long int M; // toa pikkus
int K; // vaipade arv
Carpet carpets[3];

long long int calc_carpet_size(Carpet c) {
    // leiab etteantud vaiba pindala
    return (N-c.e-c.w)*(M-c.n-c.s);
}

Carpet intersection (Carpet c1, Carpet c2) {
    // leiab vaipade c1 ja c2 ühisosa ja väljastab vaibana
    // kui ühisosa puudub, väljastab vaiba pindalaga null
    Carpet ret;
    
    ret.n = MAX(c1.n,c2.n);
    ret.s = MAX(c1.s,c2.s);
    ret.e = MAX(c1.e,c2.e);
    ret.w = MAX(c1.w,c2.w);
    
    if (M - ret.n - ret.s <= 0) {
        ret.n = M;
        ret.s = 0;
    }
    if (N - ret.e - ret.w <= 0) {
        ret.e = N;
        ret.w = 0;
    }
    
    return ret;
}

int main(int argc, char **argv)
{
    // avab failid
	ifstream fin;
    ofstream fout;
    fin.open("vaipsis.txt");
    fout.open("vaipval.txt");
    
    // loeb sisendi
    fin >> K >> N >> M;
    
    for (int i = 0; i < K; i++)
        fin >> carpets[i].n >> carpets[i].s >> carpets[i].e >> carpets[i].w;
    
    if (K == 1) { // ainult üks vaip, lihtne vastus
        fout << calc_carpet_size(carpets[0]) << endl;
    }
    
    if (K == 2) { // kaks vaipa miinus nende ühisosa
        fout << calc_carpet_size(carpets[0]) + calc_carpet_size(carpets[1])
                - calc_carpet_size(intersection(carpets[0],carpets[1])) << endl;
    }
    
    if (K == 3) { // kolm vaipa, miinus paarikaupa ühisosad
                  // pluss kõigi kolme ühisosa
        Carpet c12 = intersection(carpets[0],carpets[1]);
        Carpet c13 = intersection(carpets[0],carpets[2]);
        Carpet c23 = intersection(carpets[1],carpets[2]);
        Carpet c123 = intersection(c12,carpets[2]);
        fout << calc_carpet_size(carpets[0]) + calc_carpet_size(carpets[1])
                + calc_carpet_size(carpets[2]) - calc_carpet_size(c12)
                - calc_carpet_size(c13) - calc_carpet_size(c23)
                + calc_carpet_size(c123) << endl;
    }
    
    // failid kinni
    fin.close();
    fout.close();
    
    return 0;
}

